function Yct=CommonTrendNTS(Y,Lmax,MAL)
%
% with Moving Average 
% 
[N,P]=size(Y);
Lmax2=2*Lmax;
NT=N-Lmax2;
if P==1
    Yct=Y(Lmax+1:N-Lmax);
    Yct=CommonTrendMA(Yct,MAL); 
else
    Yct=sum(Y')'/P;
    Yct=Yct(Lmax+1:N-Lmax);
    Yct=CommonTrendMA(Yct,MAL); 
    R=ones(P,1)/P;
    Lag=zeros(P,1);
    dsmin=fun_dsmCT(Y,Yct,R,Lag,Lmax);
    Yct0=Yct;
    for count=1:10
        Rold=R;
        Lag=zeros(P,1);
        for p=1:P
            x=Yct;
            y=Y(:,p);
            [sm,r,lg]=fun_dsmT(x,y,Lmax);            
            Lag(p)=lg;
            if r<=0
                r=0;
            end
            R(p)=r;
        end
        Yct=zeros(NT,1);
        R=R/sum(R);
        for p=1:P
            y=Y(:,p);
            Yct=Yct+R(p)*y(Lmax+1+Lag(p):N-Lmax+Lag(p));
        end
        Yct=CommonTrendMA(Yct,MAL); 
        ds=fun_dsmCT(Y,Yct,R,Lag,Lmax);
        if ds < dsmin
            dsmin=ds;
            Yct0=Yct;
        end
    end
    Yct=Yct0;
end
