function CT=CommonTrendMA(y,MAL);
%
% by Moving Average: triangle weight, length = 2*MAL-1,
%
N=length(y);
CT=zeros(N,1);
weight=[1:MAL MAL-1:-1:1];
weight=weight/sum(weight);
x=[ones(MAL-1,1)*y(1); y;ones(MAL-1,1)*y(N)];
for n=1:N
    CT(n)=weight*x(n:n+2*MAL-2);
end
